﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Compiler
{
    public static class CompilerFactory
    {
        public static Compiler.ICompiler GetCompiler(CompileType compileType, string language)
        {
            Compiler.ICompiler compiler = null;
            if (language == "VisualBasic")
            {
                switch (compileType)
                {
                    case CompileType.Fragment:
                        compiler = new Compiler.VisualBasic.FragmentCompiler();
                        break;
                    case CompileType.Method:
                        compiler = new Compiler.VisualBasic.MethodCompiler();
                        break;
                    case CompileType.Class:
                        compiler = new Compiler.VisualBasic.ClassCompiler();
                        break;
                }
            }
            else if (language == "CSharp")
            {
                switch (compileType)
                {
                    case CompileType.Fragment:
                        compiler = new Compiler.CSharp.FragmentCompiler();
                        break;
                    case CompileType.Method:
                        compiler = new Compiler.CSharp.MethodCompiler();
                        break;
                    case CompileType.Class:
                        compiler = new Compiler.CSharp.ClassCompiler();
                        break;
                }
            }

            return compiler;
        }
    }
}
